"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

/**
 * Get the closest ancestor of an `element` that matches `selector`.
 *
 * @param {Element} elememt
 * @param {String} selector
 * @return {Element|Null}
 */

function closest(element, selector) {
  while (element && element.nodeType === 1) {
    if (element.matches(selector)) return element;
    element = element.parentNode;
  }

  return null;
}

/**
 * Export.
 *
 * @type {Function}
 */

exports.default = closest;